#ifndef _Chgroup2D_h_
#define _Chgroup2D_h_

#include <TNamed.h>
#include "GroupInfo.h"
#include <TH2I.h>

class ChGroup2D : public TNamed {
private:
    GroupInfo fInfox;
    GroupInfo fInfoy;
    TH2I fHist;
public:
 ChGroup2D(const char * name, const char * title, Int_t nch) :
	TNamed(name, title),
	fInfox(fName + "_infox", title, nch),
	fInfoy(fName + "_infoy", title, nch),
	fHist(fName + "_hist", title, 6400, 0, 64000, 6400, 0, 64000) {
	  //	  printf("ChGroup: %s\n",name);
    };
    ~ChGroup2D() {
    };

    Int_t Fill2D(Int_t chx, Double_t tx, Int_t chy, Double_t ty) {
      // 	fHist.Fill(tx,ty);
	//	fHist.Print();
      //      printf("%d %d: %lf %d %d: %lf\n",chx, fInfox.GetCh(chx), tx, chy, fInfoy.GetCh(chy), ty);
      if (fInfox.GetCh(chx)&&fInfoy.GetCh(chy)){
	  tx=(tx-fInfox.GetZero(chx))*fInfox.GetGain(chx);
	  ty=(ty-fInfoy.GetZero(chy))*fInfoy.GetGain(chy);
	  //	  printf("         %d %d: %lf %d %d: %lf\n",chx, fInfox.GetCh(chx), tx, chy, fInfoy.GetCh(chy), ty);
	  return         fHist.Fill(tx,ty);
      }
      return 0;
    };

    void Draw(Option_t * opt = "") {
	fHist.Draw(opt);
    };

    GroupInfo * GetInfox() {
	return & fInfox;
    };

    GroupInfo * GetInfoy() {
	return & fInfoy;
    };

    GroupInfo * SetInfox(GroupInfo *info) {
	fInfox = *info;
    };

    GroupInfo * SetInfoy(GroupInfo *info) {
	fInfoy = *info;
    };


    void Reset() {
	fHist.Reset();
    };

    ClassDef(ChGroup2D, 0)
};

#endif
