#include "GateNet.h"
#include <arpa/inet.h>

ClassImp(GateNet)

void GateNet::RecvEvent() {

    /* internal classee */

    class datum {
    private:
	UChar_t buf[8];
    public:
	datum() { };
	~datum() { };

	void Print(Option_t * opt = "") {
	    if (buf[0] == 0) {
		// printf("response: empty\n");
	    } else {
		printf("response:");
		for (int i=0; i<8; i++) {
		    printf(" %02x", buf[i]);
		}
		switch (buf[0]) {
		case 0x5b:
		    printf(" T0\n");
		    break;
		case 0x5c:
		    printf(" clock\n");
		    break;
		default:
		    printf(" type=%02x\n", buf[0]);
		}
	    }
	};
    };

    class response {
    private:
	UInt_t rawlen; // but network order
	datum item[2]; // Only T0 + Clock for Run44
    public:
	response() { };
	~response() { };

	Int_t GetN() {
	    return 2 * ntohl(rawlen) / sizeof(item[0]);
	};

	void Print(Option_t * opt = "") {
	    int nitem = GetN();
	    for (int i=0; i<nitem; i++) {
		item[i].Print(opt);
	    }
	};

	UChar_t * GetBuffer() {
	    return (UChar_t *)item;
	};

	Int_t GetNbytes() {
	    return sizeof(item);
	};
    };

    class request {
    private:
	union {
	    Char_t p8[8];
	    UInt_t p32[2];
	};
    public:
	request(Int_t nbytes = 0) {
	    p32[0] = htonl(0xA3000000);
	    p32[1] = htonl(nbytes);
	};
	~request() { };

	void SetLen(Int_t n) {
	    p32[1] = ntohl(n);
	};

	Int_t GetLen() {
	    return ntohl(p32[1]);
	};
    };

    /* function body */
    assert(fSocket);

    assert(fSocket->IsValid());

    request req;
    response rsp;

    while (1) {
	int ret;
	int len = 8; // sizeof(rsp);
//	printf("len = %d\n", len);
	req.SetLen(len);
	ret = fSocket->SendRaw(&req, sizeof(req));
	assert(ret >= 0);

	ret = fSocket->RecvRaw(&rsp, sizeof(rsp), kDontBlock);
	assert(ret >= 0);

//	rsp.Print();

	if (rsp.GetN() > 0)
	    break;
    }

//    printf("GetN = %d, bytes = %d\n", rsp.GetN(), rsp.GetNbytes());

    SetData(rsp.GetBuffer(), rsp.GetNbytes());
};


#if 0
main(int argc, char ** argv)
{
    int ret;
    TSocket s("192.168.0.64", 23);
    assert(s.IsValid());

    s.SetOption(kNoDelay, 1);

    while (1) {
	req.SetLen(sizeof(rsp));
	ret = s.SendRaw(&req, sizeof(req));
	assert(ret >= 0);

	ret = s.RecvRaw(&rsp, sizeof(rsp), kDontBlock);
	assert(ret >= 0);

	rsp.Print();

	gSystem->Sleep(100);
    }
}
#endif
