#include    <stdio.h>
#include    <ctype.h>
#include    <unistd.h>
#include    <stdlib.h>
#include    <string.h>
#include    <errno.h>
#include    <signal.h>
#include    <sys/param.h>
#include    <sys/types.h>
#include    <sys/socket.h>
#include    <netinet/in.h>
#include    <arpa/inet.h>
#include <netinet/tcp.h>
#ifndef TCP_QUICKACK
#define TCP_QUICKACK 12
#endif
#include    <netdb.h>
int sockfd;

#include "global.h"
/* Ф˥å³ʥॢȲǽǡ */
int v_open_vme(char *hostnm,char *portnm)
{
  struct in_addr    addr;
  struct hostent    *host;
  struct sockaddr_in    server;
  struct servent    *se;
  int   portno,opt,ret;

    /* ɥ쥹򥼥ꥢ */
  memset((char *)&server,0,sizeof(server));
  server.sin_family=AF_INET;
  
  /* ۥ̾IPɥ쥹ȲꤷƥۥȾ */
  if((addr.s_addr=inet_addr(hostnm))==-1){
    /* ۥ̾̾ΤȤƥۥȾ */
    host=gethostbyname(hostnm);
    if(host==NULL){
      /* ۥȤĤʤ */
      fprintf(stderr,"gethostbyname():error\n");
      return(-1);
    }
    memcpy(&addr,(struct in_addr *)*host->h_addr_list,sizeof(struct in_addr));
  }
  //fprintf(stderr,"addr=%s\n",inet_ntoa(addr));
  /* ۥȥɥ쥹Υå */
  server.sin_addr=addr;
  
  /* ݡֹη */
  if(isdigit(portnm[0])){
    /* Ƭ */
    if((portno=atoi(portnm))<=0){
      /* Ͳȥʲ */
      fprintf(stderr,"bad port no\n");
      return(-1);
    }
    server.sin_port=htons(portno);
  }
  else{
    if((se=getservbyname(portnm,"tcp"))==NULL){
      /* ӥ˸Ĥʤ */
      fprintf(stderr,"getservbyname():error\n");
      return(-1);
    }
    else{
      /* ӥ˸Ĥä:ݡֹ */
      server.sin_port=se->s_port;
    }
  }
  //printf("port=%d\n",ntohs(server.sin_port));
  
  /* åȤ */
  if((sockfd=socket(AF_INET,SOCK_STREAM,0))<0){
    perror("socket");
    return(-1);
  }
  opt=1;
  ret = setsockopt(sockfd, IPPROTO_TCP, TCP_NODELAY, (char *)&opt, sizeof(opt) );
  if (ret == -1) {
    printf("Couldn't setsockopt(TCP_NODELAY)\n");
    exit( EXIT_FAILURE );
  }
  ret = setsockopt( sockfd, IPPROTO_TCP, TCP_QUICKACK, (char *)&opt, sizeof(opt) );
  
  /* ͥ */
  if(connect(sockfd,(struct sockaddr *)&server,sizeof(server))==-1){
    perror("connect");
    close(sockfd);
    return(-1);
  }
  return 0;
}

int v_close_vme(void)
{
  close(sockfd);
  return 0;
}

int v_read_from_vme(unsigned char *buff,size_t size)
{
  //  size_t len;
#ifdef PTDBG
  int i;
#endif
  int rd = 0,num = 0;

  //  while(rd < size){
  while(rd < size){
    num = recv(sockfd,&buff[rd],size - rd,MSG_WAITALL);
    rd += num;
  }

#ifdef PTDBG
  printf("read:");
  for(i = 0 ; i < 4 ; i ++){
    printf("%02x",buff[i]);
  }
  printf("\n");

  /*
  printf("read:");
  for(i = 0 ; i < rd ; i ++){
    if(!(i % 4)) printf(" ");
    printf("%02x",buff[i]);
  }
  printf("\n");
  */
#endif
  return num;
}
int read_from_sitcp(unsigned char *buff)
{
  int num=0,rd = 0,size;
  unsigned int *p;
  unsigned char b[4];

  while(rd < 3){
    num = recv(sockfd,b,4,MSG_WAITALL);
    rd += num;
  }
  rd = 0;
  p = (unsigned int *)b;
  size = (int)ntohl(p[0]) - 4;
  // printf("size = %d\n",(int)size);
  while(rd < size){
    num = recv(sockfd,&buff[rd],size - rd,MSG_WAITALL);
    rd += num;
  }
  return rd;
}

int v_write_to_vme(unsigned char *data, size_t size)
{
  int rtn;
#ifdef PTDBG
  int i;
#endif
  rtn = send(sockfd, data, size,0);
  //  printf("send = %08X\n",ntohl((unsigned int *)data));

#ifdef PTDBG
  printf("write:");
  for(i = 0 ; i < (int)size ; i ++){
    if(!(i % 4)) printf(" ");
    printf("%02x",data[i]);
  }
  printf("\n");

#endif

  return 0;
}

int vme_init(char *hostnm,char *portnm)
{
  int rtn = 0;

  rtn = v_open_vme(hostnm,portnm);
  if(rtn){
    fprintf(stderr,"cnnect err\n");
    return rtn;
  }
  return EXIT_SUCCESS;
}

int quit_vme()
{
  int rtn = 0;

  rtn = v_close_vme();
  if(rtn){
    return EXIT_FAILURE;

  }
  return EXIT_SUCCESS;
}

int get_acr_state()
{
  int rtn = 0;
  int i,n;
  unsigned int data,flg;
  n = cntl.modulenum;
  data = 5; 
  flg = 0;
  for(i = 0 ; i < n ; i++){
    read_acr_register(i,&data);
    flg |= data;
    //    fprintf(stderr,"data = %d flg = %d\n",data,flg);
  }
  rtn = (int)flg;
  return rtn;
}

