#include <assert.h>
#include <unistd.h>
#include <dirent.h>
#include "MLFdatum.h"
//#include "Run44Decoder.h"

//#include <TCanvas.h>
//#include <TFile.h>
#include <math.h>
#include <stdlib.h>
//#include "module_numbers.h"
//#define TOTAL_MODULES (N_KALLIOPE_TDC_MODULES+N_NIM_TDC_MODULES+N_NIKI_3N00_MODULES)
//#include "muse_basename.h"
//#include "module_numbers.h"

//Run44Decoder * Result = NULL;

int maxevent = -1;
Int_t gap = 30;
Int_t reset_number = -1;
Bool_t use_muse_basename = kFALSE;
Bool_t use_new_algorithm = kTRUE;

char * outfilename = NULL;

int
main()
{
  int status,loss=0;
    int ret;
    int nevent = 0;
    Double_t t,tsave,dt;
    const int nbuf = 64 * 1024;
    MLFdatum item[nbuf];
#define TOTAL_M 50
#define M_RG 8
    UInt_t pulseID[TOTAL_M],pulseIDsave[TOTAL_M];
    int firstpacket[TOTAL_M];
    char module[TOTAL_M];
    int n=0; int nsave=0; int isave=0; int error=0;
    int n22[M_RG][TOTAL_M],n42[M_RG][TOTAL_M],n44[M_RG][TOTAL_M],n46[M_RG][TOTAL_M],n22sum[M_RG],RG=0,remain;

    for(int k=0; k<TOTAL_M; k++) {
      firstpacket[k]=1;
      pulseIDsave[k]=0;
      for(int j=0; j<M_RG; j++){
	n22[j][k]=n42[j][k]=n44[j][k]=n46[j][k]=n22sum[j]=0;
      }
    }
    while (1) {
	MLFdatum last_niki_tdc;

	int nitem = fread(&item, sizeof(MLFdatum), nbuf, stdin);
     
	for (int i=0; i<nitem; i++) {
	  //		  printf("%016llx\n",item[i].GetVal());
	    switch (item[i].GetType()) {
	    case 0x10: 
	      //	      if(n<N_NIM_TDC_MODULES){
		if(firstpacket[n]) {
		  isave=i;
		  firstpacket[n]=0; 
		  pulseID[n]=((int)item[i].GetCh()<<16)+item[i].GetTime();
		  module[n]='N';
		  remain=3;
		}
		else{
		  remain--;
		  if(!remain)n++;
		}
		//	      }
	      break;
	    case 0x11: /*NIM IR*/
	      RG=item[i].GetTime();
	      break;
	    case 0x20: 
	      //	      if(n<N_NIM_TDC_MODULES+N_KALLIOPE_TDC_MODULES){
		if(firstpacket[n]) {
		  firstpacket[n]=0; 
		  pulseID[n]=((UInt_t)item[i].GetCh()<<16)+item[i].GetTime();
		  module[n]='K';
		  remain=5;
		}
		else{
		  remain--;
		  if(!remain)n++;
		}
		//	      }
	      break;
	    case 0x22: /* NIM or Kalliope TDC */
	      if (nevent > reset_number) n22[RG][n-1]++;
	      break;
	    case 0x40: 
	      if(n<TOTAL_M){
		if(firstpacket[n]) {
		  firstpacket[n]=0; pulseID[n]=item[i].GetTime()/5;
		  module[n]='I';
		  remain=2;
		}
		else{
		  remain--;
		  if(!remain) n++;
		}
	      }
	      else{
		printf("No. of modules tried to exceed TOTAL_M %d\n",TOTAL_M);
		exit(1);
	      }
	      break;
	    case 0x42: /* NIKI TDC */
	      if (nevent > reset_number) n42[RG][n-1]++;
		break;
	    case 0x44: /* NIKI ADC */
	      if (nevent > reset_number) n44[RG][n-1]++;
		break;
	    case 0x46:/* NIKI ADC */
	      if (nevent > reset_number) n46[RG][n-1]++;
		break; 
	    case 0x5b:
		break;
	    case 0x5c:
		/* GateNet clock, this is end of event */
	      {
	      Long64_t v = item[i].GetVal();
	      UChar_t * p = item[i].GetBuf();
	      //              for (int ii=0; ii<8; ii++) {
	      //                printf("%02x ", p[ii]);
	      //              }
	      Double_t dummy;
	      Long64_t vv = (((Long64_t)ntohl(v & 0xFFFFFFFF)) << 32) | ntohl(v >> 32);
	      Int_t count_40MHz = (vv & 0x7FF);
	      Int_t count_32kHz = ((vv >> 11) & 0x7FFF);
	      Int_t count_1Hz = (vv >> 26) & 0xFFFFFFFF;
	      t = (Double_t)(0x47798280LL+count_1Hz) //MLF-time epoch GateNet
		+ modf((Double_t)count_32kHz *(1.0 / 32000.0), &dummy)
	      + modf((Double_t)count_40MHz * (1.0 / 40000000.0), &dummy);
	      //              printf("=> %10.6f\n", t);
	      }
	      dt=1000*(t-(tsave+0.04));
	      printf(" RG     n22     n42     n44     n46     @");
	      if(n!=nsave){
		fprintf(stderr,"No. of modules %d != %d previous @ %ld %lf\n",n,nsave,nevent,t);
		printf("!");
		error=1;
	      }
	      printf(" %d %ld %lf\n",n, nevent,t);
	      //	      for(int j=0; j<M_RG; j++){
	      for(int k=0; k<n; k++){
		int j=RG;
		printf("%c %2d,%7u,%7u,%7u,%7u,%12u",module[k],j,n22[j][k],n42[j][k],n44[j][k],n46[j][k],pulseID[k]);
		if(pulseID[k]!=pulseIDsave[k]+1) {
		  fprintf(stderr,"Pulse ID does not increment %c[%d]=%ld != %ld+1 @ %ld %lf\n",module[k],k,pulseID[k],pulseIDsave[k],nevent,t);
		  printf(" !");
		  error=1;
		}
		printf("\n");
		n22sum[j]+=n22[j][k];
	      }

	      //	      if(n!=nsave){
	      //		fprintf(stderr,"No. of modules %d != %d previous @ %ld %lf\n",n,nsave,nevent,t);
	      //		error=1;
	      //	      }
	      /*	      for(int k=0; k<n; k++){
		if(pulseID[k]!=pulseIDsave[k]+1) {
		  fprintf(stderr,"Pulse ID does not increment %c[%d]=%ld != %ld+1 @ %ld %lf\n",module[k],k,pulseID[k],pulseIDsave[k],nevent,t);
		  error=1;
		  }
		//		for(int j=0; j<k; j++){
		//		  if(module[k]==module[j]&&pulseID[k]!=pulseID[j]){
		//		    fprintf(stderr,"Pulse ID does not agree %c[%d]=%d != %c[%d]=%d @ %d %lf\n",module[k],k,pulseID[k],module[j],j,pulseID[j],nevent,t);
		//		    error=1;
		//		  }
		//		}
		}*/
	      if(error){
		for(int p=isave;p<i+1;p++)
		  //		  fprintf(stderr,"%016llx\n",item[p].GetVal());
		  fprintf(stderr,"",item[p].GetVal());
		error=0;
	      }

	      nsave=n; n=0;
	      for(int k=0; k<TOTAL_M; k++) {
		pulseIDsave[k]=pulseID[k];
		firstpacket[k]=1;
		for(int j=0; j<M_RG; j++){
		  n22[j][k]=n42[j][k]=n44[j][k]=n46[j][k]=0;
		}
	      }
		//	      }
	      /*
	      fprintf(stderr,"%d %d %d %d hits@%d %lf (%lf)\n",n22,n42,n44,n46,nevent,t,dt);

	      if(abs(dt)>10){printf("Time incriment > +/-10ms@event %d at time %lf (%lf)\n",nevent,t,dt);}
	      tsave=t;
	      if(n42!=n44||n46==0) printf("%d th packet lost@event %d with %d %d %d %d hits\n",loss,nevent,n22,n42,n44,n46);
	      if(status!=0x111) {loss++;printf("%d th packet lost@event %d with status %03x\n",loss,nevent,status);}
	      status=0x000;n22=n42=n44=n46=0;
	      }
	      */

		if (nevent > reset_number) nevent++;

		/* clear hitlists only, should be called event-by-event */
		/* Histograms are not affected */
		//		Result->Clear();
		break;
	    default:
		fprintf(stderr, "%d type = %02x %016llx\n", i, item[i].GetType(), item[i].GetVal());
	    }
	}

	if (maxevent > 0 && nevent > maxevent)
	    break;

	if (nitem < nbuf)
	    break;
    }
    printf("Total event %d\n",nevent);
    for(int j=0;j<M_RG;j++) printf("n22sum[%1d]",j);printf("\n");
    for(int j=0;j<M_RG;j++) printf("%9d",n22sum[j]);printf("\n");

}

