#include <assert.h>
#include <Rtypes.h>

#include "FPGATDC32.h"

#include "module_numbers.h"

#define	NW(X)	(sizeof(X)/4)

class FPGATDC32decoder {
private:
public:
    FPGATDC32decoder() { };

    virtual void OverFlowHandler(const FPGATDC32hit & raw) { };

    virtual ~FPGATDC32decoder() { };

    virtual void Push(Int_t ch, Int_t time, const FPGATDC32hit & raw) { };

    void decode_finesse(const UInt_t * const p, Int_t nword, Int_t fslot) throw(char const *) {
	const finheader * const finhdr = (const finheader * const)p;
	const finfooter * const finftr = (const finfooter * const)(p+nword-NW(finfooter));

	if (finhdr->magic != 0xFFAA0000) {
	    throw("Bad Header Magic != 0xFFAA0000");
	}

	if ((finftr->magic & 0xFFFF0000) != 0xFF550000) {
	    throw("Bad Footer Magic != 0xFF55XXXX");
	}

	FPGATDC32hit * q = (FPGATDC32hit *)(&finhdr[1]);
	int nhit = nword - NW(*finhdr) - NW(*finftr);
	UShort_t start = finftr->start;
	for (int i=0; i<nhit; i++) {
	    if (q[i].IsOverflowed())
		OverFlowHandler(q[i]);

	    Int_t ch = q[i].GetCh()+32*fslot;
	    Int_t time = (q[i].time - start)&0xFFFF;

	    Push(ch, time, q[i]);
	}
    };

};
