#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <time.h>
#include <string.h>
#include "global.h"
#include "read_setting.h"

void set_list_window();
void set_pha_window();

void create_def_file()/*for niki system*/
{
  char b[256];

  sprintf(b,FIRST_SET_FILE);
  system(b);

}

int read_address_def(struct control *c)
{
  FILE *fp;
  char buff[1024];
  char b[256];
  int n = 0;
  unsigned int ad[1024];
  int state[24];
  int flg=0;
  int max = MODULE_MAX;

  sprintf(b,ADDRESS_SET_FILE);

  if((fp = fopen(b,"r")) == NULL)
    return 1;
  while(fgets(buff,1024,fp) != NULL){
    if(buff[0] != '0') continue;
    ad[n] = 0;

    sscanf(buff,"%x,%d",&ad[n],&state[n]);

    m_reg[n].address = ad[n];
    c->state[n]= state[n];
    fprintf(stderr,"read ad = %x %d %d\n",m_reg[n].address,c->state[n],flg);
    if(n & (flg != state[n])){/*not equal state*/
      break;

    }
    if(ad[n]){
      flg = state[n];
      n++;
    }
  }
  fclose(fp);
  if(n > max){
    n = max;
  }
  c->modulenum = n;
  if(n > 7)
    return 1;
  return 0;
}

void set_a3100_default(int module)
{
  int j,n;
  n = module;

  m_reg[n].irqvr = 0;
  m_reg[n].irqcr = 0;
  m_reg[n].mcstar = 0xee;
  m_reg[n].mcstcrm = 0x0;
  m_reg[n].amr = 0x8;
  m_reg[n].ecpvr = 0;
  m_reg[n].ldspvr = 0;
  m_reg[n].mcsr = 3;
  for(j = 0 ; j < 16 ; j++){
    m_reg[n].ccr[j] = 3;
    m_reg[n].czlr[j] = 0x800;
    m_reg[n].clldr[j] = 0x1a0;
    m_reg[n].ccgr[j] = 0;
    m_reg[n].cpmr[j] = 0;
    m_reg[n].cpvr[j] = 0x64;
    m_reg[n].sproicr[j] = 0;
    m_reg[n].nproicr[j] = 0;
    
  }
}

void set_a3200_default(int module)
{
  int j,n;
  n = module;

  m_reg[n].irqvr = 0;
  m_reg[n].irqcr = 0;
  m_reg[n].mcstar = 0xee;
  m_reg[n].mcstcrm = 0x0;
  m_reg[n].amr = 0x8;
  m_reg[n].ecpvr = 0;
  m_reg[n].ldspvr = 0;
  m_reg[n].mcsr = 0;
  for(j = 0 ; j < 16 ; j++){
    m_reg[n].ccr[j] = 0;
    m_reg[n].czlr[j] = 0x800;
    m_reg[n].clldr[j] = 0x52;
    m_reg[n].ccgr[j] = 0;
    m_reg[n].cpmr[j] = 0;
    m_reg[n].cpvr[j] = 0x64;
    m_reg[n].sproicr[j] = 0;
    m_reg[n].nproicr[j] = 0;
    
  }
}
void set_a3300_default(int module)
{
  int j,n;
  n = module;

  m_reg[n].irqvr = 0;
  m_reg[n].irqcr = 0;
  m_reg[n].mcstar = 0xee;
  m_reg[n].mcstcrm = 0x0;
  m_reg[n].amr = 0x8;
  m_reg[n].ecpvr = 0;
  m_reg[n].ldspvr = 0;
  m_reg[n].mcsr = 0;
  for(j = 0 ; j < 16 ; j++){
    m_reg[n].ccr[j] = 0;
    m_reg[n].ctfsr[j] = 0;
    m_reg[n].ccgr[j] = 0;
    m_reg[n].cpmr[j] = 0;
    m_reg[n].cpvr[j] = 0x64;
    m_reg[n].sproicr[j] = 0;
    m_reg[n].nproicr[j] = 0;
    
  }

}
void set_a3400_default(int module)
{
  int j,n;
  n = module;

  m_reg[n].irqvr = 0;
  m_reg[n].irqcr = 0;
  m_reg[n].mcstar = 0xee;
  m_reg[n].mcstcrm = 0x0;
  m_reg[n].amr = 0x8;
  m_reg[n].ecpvr = 0;
  m_reg[n].ldspvr = 0;
  m_reg[n].mcsr = 3;
  for(j = 0 ; j < 16 ; j++){
    m_reg[n].ccr[j] = 3;
    m_reg[n].czlr[j] = 0x800;
    m_reg[n].clldr[j] = 0x1a0;
    m_reg[n].cgpwr[j] = 0x28;
    m_reg[n].ccgr[j] = 0;
    m_reg[n].cpmr[j] = 0;
    m_reg[n].cpvr[j] = 0x64;
    m_reg[n].sproicr[j] = 0;
    m_reg[n].nproicr[j] = 0;
    
  } 
}

int read_setting_def(struct data_file *d,struct control *cntl)
{
  char *fname,*h;
  int n,i;

  n = cntl->modulenum;

  for(i = 0 ; i < n ; i++){
    if(m_reg[i].mir == 0x3100) set_a3100_default(i);
    if(m_reg[i].mir == 0x3200) set_a3200_default(i);
    if(m_reg[i].mir == 0x3300) set_a3300_default(i);
    if(m_reg[i].mir == 0x3400) set_a3400_default(i);
  }

  h = getenv("HOME");
  /**************** A3100*********************/
  fname = d->setting;
  sprintf(fname,"%s%s",h,"/A3100v2/a3100_setting.def");
  read_a3100_setting(fname);
  /**************** A3200*********************/
  fname = d->setting2;
  sprintf(fname,"%s%s",h,"/A3100v2/a3200_setting.def");
  read_a3200_setting(fname);
  /**************** A3300*********************/
  fname = d->setting3;
  sprintf(fname,"%s%s",h,"/A3100v2/a3300_setting.def");
  read_a3300_setting(fname);
  /**************** A3400*********************/
  fname = d->setting4;
  sprintf(fname,"%s%s",h,"/A3100v2/a3400_setting.def");
  read_a3400_setting(fname);

  return 0;
}

int read_setting_file(char *fname)
{
  /*
    no use
    任意の場所から設定ファイルを読む
   */
  FILE *fp;
  char buff[1024];
  int rtn;
  if((fp = fopen(fname,"r")) == NULL)
    return -1;
  fgets(buff,1023,fp);
  fclose(fp); 

  rtn = strncmp(buff,"#A3100",6);
  if(!rtn){
    read_a3100_setting(fname);
    fprintf(stderr,"READ OK. Read A3100 setting.\n");
    return rtn;
  }

  rtn = strncmp(buff,"#A3200",6);
  if(!rtn){
    fprintf(stderr,"READ OK. Read A3200 setting.\n");
    //    yes_dialog("READ","OK. Read A3200 setting.");
    return rtn;
  }

  rtn = strncmp(buff,"#A3300",6);
  if(!rtn){
    fprintf(stderr,"READ OK. Read A3300 setting.\n");
    //    yes_dialog("READ","OK. Read A3300 setting.");
    return rtn;
  }
  rtn = strncmp(buff,"#A3400",6);
  if(!rtn){
    fprintf(stderr,"READ OK. Read A3400 setting.\n");
    //    yes_dialog("READ","OK. Read A3400 setting.");
    return rtn;
  }

  return -1;
}

void read_a3100_setting(char *fname)
{
  FILE *fp;
  int i,ch;
  char buff[1024];
  char c;

  if((fp = fopen(fname,"r")) == NULL)
    return;
  ch = 0;
  fprintf(stderr,"read_a3100_setting %s\n",fname);
  while(fgets(buff,1024,fp) != NULL){
    //  fprintf(stderr,"%s\n",buff);
    switch(buff[0])
      {
      case 'r':
	sscanf(buff,"%c,%d,",&c,&i);
	if(m_reg[i].mir != 0x3100) break;
	//	fprintf(stderr,"num = %d \n",i);
	sscanf(buff,"%c,%d,%X,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,
	       &m_reg[i].irqvr,
	       &m_reg[i].irqcr,
	       &m_reg[i].mcstar,
	       &m_reg[i].mcstcrm,
	       &m_reg[i].amr,
	       &m_reg[i].ecpvr,
	       &m_reg[i].ldspvr,
	       &m_reg[i].mcsr
	       );
	m_reg[i].mcsr &= 0x373;
	
#ifdef DEBUG	
	fprintf(stderr,"module = %d %X %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].irqvr,
	       m_reg[i].irqcr,
	       m_reg[i].mcstar,
	       m_reg[i].mcstcrm,
	       m_reg[i].amr,
	       m_reg[i].ecpvr,
	       m_reg[i].ldspvr,
	       m_reg[i].mcsr
	       );
#endif	
      
	break;
      case 'c':
	sscanf(buff,"%c,%d,%d,",&c,&i,&ch);
	if(m_reg[i].mir != 0x3100) break;
	sscanf(buff,"%c,%d,%d,%X,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,&ch,
	       &m_reg[i].ccr[ch],
	       &m_reg[i].czlr[ch],
	       &m_reg[i].clldr[ch],
	       &m_reg[i].ccgr[ch],
	       &m_reg[i].cpmr[ch],
	       &m_reg[i].cpvr[ch],
	       &m_reg[i].sproicr[ch],
	       &m_reg[i].nproicr[ch]
	       );

	//	channel_gain[i][ch]= return_channel_gain((int)m_reg[i].ccgr[ch]);
#ifdef DEBUG	
	fprintf(stderr,"ch = %d %X %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].ccr[ch],
	       m_reg[i].czlr[ch],
	       m_reg[i].clldr[ch],
	       m_reg[i].ccgr[ch],
	       m_reg[i].cpmr[ch],
	       m_reg[i].cpvr[ch],
	       m_reg[i].sproicr[ch],
	       m_reg[i].nproicr[ch]
	       );
#endif	
	break;
      default:
	break;
      }

  }

  fclose(fp); 

}


void read_a3200_setting(char *fname)
{
  FILE *fp;
  int i,ch;
  char buff[1024];
  char c;

  if((fp = fopen(fname,"r")) == NULL)
    return;
  ch = 0;

  while(fgets(buff,1024,fp) != NULL){

    switch(buff[0])
      {
      case 'r':
	sscanf(buff,"%c,%d,",&c,&i);
	if(m_reg[i].mir != 0x3200) break;
	//	fprintf(stderr,"num = %d \n",i);
	sscanf(buff,"%c,%d,%X,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,
	       &m_reg[i].irqvr,
	       &m_reg[i].irqcr,
	       &m_reg[i].mcstar,
	       &m_reg[i].mcstcrm,
	       &m_reg[i].amr,
	       &m_reg[i].ecpvr,
	       &m_reg[i].ldspvr,
	       &m_reg[i].mcsr
	       );
	m_reg[i].mcsr &= 0x373;
	
#ifdef DEBUG	
	fprintf(stderr,"module = %d %X %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].irqvr,
	       m_reg[i].irqcr,
	       m_reg[i].mcstar,
	       m_reg[i].mcstcrm,
	       m_reg[i].amr,
	       m_reg[i].ecpvr,
	       m_reg[i].ldspvr,
	       m_reg[i].mcsr
	       );
#endif	
	break;
      case 'c':
	sscanf(buff,"%c,%d,%d,",&c,&i,&ch);
	if(m_reg[i].mir != 0x3200) break;
	sscanf(buff,"%c,%d,%d,%X,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,&ch,
	       &m_reg[i].ccr[ch],
	       &m_reg[i].czlr[ch],
	       &m_reg[i].clldr[ch],
	       &m_reg[i].ccgr[ch],
	       &m_reg[i].cpmr[ch],
	       &m_reg[i].cpvr[ch],
	       &m_reg[i].sproicr[ch],
	       &m_reg[i].nproicr[ch]
	       );

	//	channel_gain[i][ch]= return_channel_gain((int)m_reg[i].ccgr[ch]);
#ifdef DEBUG	
	fprintf(stderr,"ch = %d %X %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].ccr[ch],
	       m_reg[i].czlr[ch],
	       m_reg[i].clldr[ch],
	       m_reg[i].ccgr[ch],
	       m_reg[i].cpmr[ch],
	       m_reg[i].cpvr[ch],
	       m_reg[i].sproicr[ch],
	       m_reg[i].nproicr[ch]
	       );
#endif	
	break;
      default:
	break;
      }

  }

  fclose(fp); 

}

void read_a3300_setting(char *fname)
{
  FILE *fp;
  int i,ch;
  char buff[1024];
  char c;

  if((fp = fopen(fname,"r")) == NULL)
    return;
  ch = 0;

  while(fgets(buff,1024,fp) != NULL){

    switch(buff[0])
      {
      case 'r':
	sscanf(buff,"%c,%d,",&c,&i);
	if(m_reg[i].mir != 0x3300) break;
	//	fprintf(stderr,"num = %d \n",i);
	sscanf(buff,"%c,%d,%X,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,
	       &m_reg[i].irqvr,
	       &m_reg[i].irqcr,
	       &m_reg[i].mcstar,
	       &m_reg[i].mcstcrm,
	       &m_reg[i].amr,
	       &m_reg[i].ecpvr,
	       &m_reg[i].ldspvr,
	       &m_reg[i].mcsr
	       );
	m_reg[i].mcsr &= 0x373;
	
#ifdef DEBUG	
	fprintf(stderr,"module = %d %X %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].irqvr,
	       m_reg[i].irqcr,
	       m_reg[i].mcstar,
	       m_reg[i].mcstcrm,
	       m_reg[i].amr,
	       m_reg[i].ecpvr,
	       m_reg[i].ldspvr,
	       m_reg[i].mcsr
	       );
#endif	
	break;
      case 'c':
	sscanf(buff,"%c,%d,%d,",&c,&i,&ch);
	if(m_reg[i].mir != 0x3300) break;
	sscanf(buff,"%c,%d,%d,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,&ch,
	       &m_reg[i].ccr[ch],
	       &m_reg[i].ctfsr[ch],
	       &m_reg[i].ccgr[ch],
	       &m_reg[i].cpmr[ch],
	       &m_reg[i].cpvr[ch],
	       &m_reg[i].sproicr[ch],
	       &m_reg[i].nproicr[ch]
	       );

	//	channel_gain[i][ch]= return_channel_gain((int)m_reg[i].ccgr[ch]);
#ifdef DEBUG	
	fprintf(stderr,"ch = %d %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].ccr[ch],
	       m_reg[i].ctfsr[ch],
	       m_reg[i].ccgr[ch],
	       m_reg[i].cpmr[ch],
	       m_reg[i].cpvr[ch],
	       m_reg[i].sproicr[ch],
	       m_reg[i].nproicr[ch]
	       );
#endif	
	break;
      default:
	break;
      }

  }

  fclose(fp); 
}

void read_a3400_setting(char *fname)
{
  FILE *fp;
  int i,ch;
  char buff[1024];
  char c;

  if((fp = fopen(fname,"r")) == NULL)
    return;
  ch = 0;

  while(fgets(buff,1024,fp) != NULL){

    switch(buff[0])
      {
      case 'r':
	sscanf(buff,"%c,%d,",&c,&i);
	if(m_reg[i].mir != 0x3400) break;
	//	fprintf(stderr,"num = %d \n",i);
	sscanf(buff,"%c,%d,%X,%X,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,
	       &m_reg[i].irqvr,
	       &m_reg[i].irqcr,
	       &m_reg[i].mcstar,
	       &m_reg[i].mcstcrm,
	       &m_reg[i].amr,
	       &m_reg[i].ecpvr,
	       &m_reg[i].ldspvr,
	       &m_reg[i].comgpwr,
	       &m_reg[i].mcsr
	       );
	m_reg[i].mcsr &= 0x373;
	
#ifdef DEBUG	
	fprintf(stderr,"module = %d %X %X %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].irqvr,
	       m_reg[i].irqcr,
	       m_reg[i].mcstar,
	       m_reg[i].mcstcrm,
	       m_reg[i].amr,
	       m_reg[i].ecpvr,
	       m_reg[i].ldspvr,
	       m_reg[i].comgpwr,
	       m_reg[i].mcsr
	       );
#endif	
      
	break;
      case 'c':
	sscanf(buff,"%c,%d,%d,",&c,&i,&ch);
	if(m_reg[i].mir != 0x3400) break;
	sscanf(buff,"%c,%d,%d,%X,%X,%X,%X,%X,%X,%X,%X,%X",
	       &c,&i,&ch,
	       &m_reg[i].ccr[ch],
	       &m_reg[i].czlr[ch],
	       &m_reg[i].clldr[ch],
	       &m_reg[i].cgpwr[ch],
	       &m_reg[i].ccgr[ch],
	       &m_reg[i].cpmr[ch],
	       &m_reg[i].cpvr[ch],
	       &m_reg[i].sproicr[ch],
	       &m_reg[i].nproicr[ch]
	       );

	//	channel_gain[i][ch]= return_channel_gain((int)m_reg[i].ccgr[ch]);
#ifdef DEBUG	
	fprintf(stderr,"ch = %d %X %X %X %X %X %X %X %X %X\n",
	       i,
	       m_reg[i].ccr[ch],
	       m_reg[i].czlr[ch],
	       m_reg[i].clldr[ch],
	       m_reg[i].cgpwr[ch],
	       m_reg[i].ccgr[ch],
	       m_reg[i].cpmr[ch],
	       m_reg[i].cpvr[ch],
	       m_reg[i].sproicr[ch],
	       m_reg[i].nproicr[ch]
	       );
#endif	
	break;
      default:
	break;
      }

  }

  fclose(fp); 



}


